// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_LF_MOM_BACKEND/grmi"
	meta "LAPP_LF_MOM_BACKEND/meta/base"
	model "LAPP_LF_MOM_BACKEND/models/base"
	"fmt"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : WorkLineWorkPlaceLstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : WorkLineWorkPlaceLst的数据访问对象实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-22 16:03:30
 *
 ******************************************************************************/
type WorkLineWorkPlaceLstDAOImplement struct {
	session *xorm.Session
	meta    *grmi.Entity
	plantNr int
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewWorkLineWorkPlaceLstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个WorkLineWorkPlaceLstDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *
 * @Function Parameters      : 基本主键
 *
 * @Return Value             : WorkLineWorkPlaceLstDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-22 16:03:30
 *
 ******************************************************************************/
func NewWorkLineWorkPlaceLstDAOImplement(session *xorm.Session, plantNr int, userid string) *WorkLineWorkPlaceLstDAOImplement {
	return &WorkLineWorkPlaceLstDAOImplement{session, &meta.WorkLineWorkPlaceLst, plantNr, userid}
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkLineWorkPlaceLstDAO.InsertOne
 *
 ******************************************************************************/
func (impl *WorkLineWorkPlaceLstDAOImplement) InsertOne(entity *model.WorkLineWorkPlaceLst) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkLineWorkPlaceLstDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *WorkLineWorkPlaceLstDAOImplement) DeleteOne(workLineId string, workPlaceNr int) error {
	_, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, workLineId, workPlaceNr}).Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkLineWorkPlaceLstDAO.SelectOne
 *
 ******************************************************************************/
func (impl *WorkLineWorkPlaceLstDAOImplement) SelectOne(workLineId string, workPlaceNr int) (*model.WorkLineWorkPlaceLst, error) {
	var data model.WorkLineWorkPlaceLst
	ok, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, workLineId, workPlaceNr}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkLineWorkPlaceLstDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *WorkLineWorkPlaceLstDAOImplement) UpdateOne(entity *model.WorkLineWorkPlaceLst) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkLineWorkPlaceLstDAO.Insert
 *
 ******************************************************************************/
func (impl *WorkLineWorkPlaceLstDAOImplement) Insert(entities *[]model.WorkLineWorkPlaceLst) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
	}
	_, err := impl.session.Table(impl.meta.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkLineWorkPlaceLstDAO.Delete
 *
 ******************************************************************************/
func (impl *WorkLineWorkPlaceLstDAOImplement) Delete(entities *[]model.WorkLineWorkPlaceLst) error {
	for _, entity := range *entities {
		entity.PlantNr = impl.plantNr
		_, err := impl.session.Table(impl.meta.TableName).ID(entity.GetKey()).Delete(impl.meta.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkLineWorkPlaceLstDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *WorkLineWorkPlaceLstDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.WorkLineWorkPlaceLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkLineWorkPlaceLstDAO.Select
 *
 ******************************************************************************/
func (impl *WorkLineWorkPlaceLstDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.WorkLineWorkPlaceLst, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.WorkLineWorkPlaceLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	session = session.OrderBy(meta.WorkLineWorkPlaceLst_PlantNr.ColumnName)
	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.WorkLineWorkPlaceLst, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkLineWorkPlaceLstDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *WorkLineWorkPlaceLstDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.WorkLineWorkPlaceLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(impl.meta.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by " + meta.WorkLineWorkPlaceLst_PlantNr.ColumnName
	if orderByFields != nil {
		for _, field := range orderByFields {
			orderBy += ", " + field.ColumnName
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.WorkLineWorkPlaceLst, 0, 10)
	if where != "" {
		where = " where " + where
	}
	err = impl.session.Table(impl.meta.TableName).SQL("select * from "+impl.meta.TableName+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkLineWorkPlaceLstDAO.Update
 *
 ******************************************************************************/
func (impl *WorkLineWorkPlaceLstDAOImplement) Update(entities *[]model.WorkLineWorkPlaceLst) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
		_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkLineWorkPlaceLstDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *WorkLineWorkPlaceLstDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.WorkLineWorkPlaceLst, columns ...string) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.WorkLineWorkPlaceLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	columns = append(columns, meta.WorkLineWorkPlaceLst_LastUser.ColumnName)
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkLineWorkPlaceLstDAO.SelectAllot
 *
 ******************************************************************************/
func (impl *WorkLineWorkPlaceLstDAOImplement) SelectAllot(workLineId string) ([]model.WorkPlace, error) {

	data := make([]model.WorkPlace, 0)
	session := impl.session.Table(meta.WorkPlace.TableName).Join("LEFT", meta.WorkLineWorkPlaceLst.TableName, "WorkLineWorkPlaceLst.PlantNr = WorkPlace.PlantNr and WorkLineWorkPlaceLst.WorkPlaceNr = WorkPlace.WorkPlaceNr").Where("WorkLineWorkPlaceLst.PlantNr = ? and WorkLineWorkPlaceLst.WorkLineId = ?", impl.plantNr, workLineId)

	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkLineWorkPlaceLstDAO.SelectUnAllot
 *
 ******************************************************************************/
func (impl *WorkLineWorkPlaceLstDAOImplement) SelectUnAllot(workSpaces []int) ([]model.WorkPlace, error) {

	data := make([]model.WorkPlace, 0)
	session := impl.session.Table(meta.WorkPlace.TableName).Where("PlantNr = ?", impl.plantNr).NotIn("WorkPlaceNr", workSpaces)

	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}